/**
 * COCTMT230100UVPackagedMedicine.java
 *
 * File generated from the medication::COCTMT230100UVPackagedMedicine uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class COCTMT230100UVPackagedMedicine.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "COCT_MT230100UV.PackagedMedicine", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"id",
	"code",
	"name",
	"formCode",
	"lotNumberText",
	"capacityQuantity",
	"capTypeCode",
	"asManufacturedProduct",
	"asSuperContent",
	"subContent",
	"classCode",
	"determinerCode",
	"nullFlavor"
})
@XmlRootElement(name = "COCT_MT230100UV.PackagedMedicine")
public class COCTMT230100UVPackagedMedicine implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.infr.AllInfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId> templateId;
	@XmlElement(name = "id", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.II id;
	@XmlElement(name = "code", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.CE code;
	@XmlElement(name = "name", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication.TN> name;
	@XmlElement(name = "formCode", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.CE formCode;
	@XmlElement(name = "lotNumberText", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.ST1 lotNumberText;
	@XmlElement(name = "capacityQuantity", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.PQ capacityQuantity;
	@XmlElement(name = "capTypeCode", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.CE capTypeCode;
	@XmlElement(name = "asManufacturedProduct", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication.COCTMT230100UVManufacturedProduct> asManufacturedProduct;
	@XmlElement(name = "asSuperContent", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.COCTMT230100UVSuperContent asSuperContent;
	@XmlElement(name = "subContent", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.COCTMT230100UVSubContent subContent;
	@XmlAttribute(name = "classCode", required = true)
	public net.ihe.gazelle.medication.EntityClassContainer classCode;
	@XmlAttribute(name = "determinerCode", required = true)
	public net.ihe.gazelle.medication.EntityDeterminer determinerCode;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.medication.NullFlavor nullFlavor;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.realmCode.add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.realmCode.remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public net.ihe.gazelle.infr.AllInfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(net.ihe.gazelle.infr.AllInfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.infr.AllInfrastructureRootTemplateId templateId_elt) {
	    this.templateId.add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.infr.AllInfrastructureRootTemplateId templateId_elt) {
	    this.templateId.remove(templateId_elt);
	}
	
	/**
	 * Return id.
	 * @return id
	 */
	public net.ihe.gazelle.medication.II getId() {
	    return id;
	}
	
	/**
	 * Set a value to attribute id.
	 * @param id.
	 */
	public void setId(net.ihe.gazelle.medication.II id) {
	    this.id = id;
	}
	
	
	
	
	/**
	 * Return code.
	 * @return code
	 */
	public net.ihe.gazelle.medication.CE getCode() {
	    return code;
	}
	
	/**
	 * Set a value to attribute code.
	 * @param code.
	 */
	public void setCode(net.ihe.gazelle.medication.CE code) {
	    this.code = code;
	}
	
	
	
	
	/**
	 * Return name.
	 * @return name
	 */
	public List<net.ihe.gazelle.medication.TN> getName() {
		if (name == null) {
	        name = new ArrayList<net.ihe.gazelle.medication.TN>();
	    }
	    return name;
	}
	
	/**
	 * Set a value to attribute name.
	 * @param name.
	 */
	public void setName(List<net.ihe.gazelle.medication.TN> name) {
	    this.name = name;
	}
	
	
	
	/**
	 * Add a name to the name collection.
	 * @param name_elt Element to add.
	 */
	public void addName(net.ihe.gazelle.medication.TN name_elt) {
	    this.name.add(name_elt);
	}
	
	/**
	 * Remove a name to the name collection.
	 * @param name_elt Element to remove
	 */
	public void removeName(net.ihe.gazelle.medication.TN name_elt) {
	    this.name.remove(name_elt);
	}
	
	/**
	 * Return formCode.
	 * @return formCode
	 */
	public net.ihe.gazelle.medication.CE getFormCode() {
	    return formCode;
	}
	
	/**
	 * Set a value to attribute formCode.
	 * @param formCode.
	 */
	public void setFormCode(net.ihe.gazelle.medication.CE formCode) {
	    this.formCode = formCode;
	}
	
	
	
	
	/**
	 * Return lotNumberText.
	 * @return lotNumberText
	 */
	public net.ihe.gazelle.medication.ST1 getLotNumberText() {
	    return lotNumberText;
	}
	
	/**
	 * Set a value to attribute lotNumberText.
	 * @param lotNumberText.
	 */
	public void setLotNumberText(net.ihe.gazelle.medication.ST1 lotNumberText) {
	    this.lotNumberText = lotNumberText;
	}
	
	
	
	
	/**
	 * Return capacityQuantity.
	 * @return capacityQuantity
	 */
	public net.ihe.gazelle.medication.PQ getCapacityQuantity() {
	    return capacityQuantity;
	}
	
	/**
	 * Set a value to attribute capacityQuantity.
	 * @param capacityQuantity.
	 */
	public void setCapacityQuantity(net.ihe.gazelle.medication.PQ capacityQuantity) {
	    this.capacityQuantity = capacityQuantity;
	}
	
	
	
	
	/**
	 * Return capTypeCode.
	 * @return capTypeCode
	 */
	public net.ihe.gazelle.medication.CE getCapTypeCode() {
	    return capTypeCode;
	}
	
	/**
	 * Set a value to attribute capTypeCode.
	 * @param capTypeCode.
	 */
	public void setCapTypeCode(net.ihe.gazelle.medication.CE capTypeCode) {
	    this.capTypeCode = capTypeCode;
	}
	
	
	
	
	/**
	 * Return asManufacturedProduct.
	 * @return asManufacturedProduct
	 */
	public List<net.ihe.gazelle.medication.COCTMT230100UVManufacturedProduct> getAsManufacturedProduct() {
		if (asManufacturedProduct == null) {
	        asManufacturedProduct = new ArrayList<net.ihe.gazelle.medication.COCTMT230100UVManufacturedProduct>();
	    }
	    return asManufacturedProduct;
	}
	
	/**
	 * Set a value to attribute asManufacturedProduct.
	 * @param asManufacturedProduct.
	 */
	public void setAsManufacturedProduct(List<net.ihe.gazelle.medication.COCTMT230100UVManufacturedProduct> asManufacturedProduct) {
	    this.asManufacturedProduct = asManufacturedProduct;
	}
	
	
	
	/**
	 * Add a asManufacturedProduct to the asManufacturedProduct collection.
	 * @param asManufacturedProduct_elt Element to add.
	 */
	public void addAsManufacturedProduct(net.ihe.gazelle.medication.COCTMT230100UVManufacturedProduct asManufacturedProduct_elt) {
	    this.asManufacturedProduct.add(asManufacturedProduct_elt);
	}
	
	/**
	 * Remove a asManufacturedProduct to the asManufacturedProduct collection.
	 * @param asManufacturedProduct_elt Element to remove
	 */
	public void removeAsManufacturedProduct(net.ihe.gazelle.medication.COCTMT230100UVManufacturedProduct asManufacturedProduct_elt) {
	    this.asManufacturedProduct.remove(asManufacturedProduct_elt);
	}
	
	/**
	 * Return asSuperContent.
	 * @return asSuperContent
	 */
	public net.ihe.gazelle.medication.COCTMT230100UVSuperContent getAsSuperContent() {
	    return asSuperContent;
	}
	
	/**
	 * Set a value to attribute asSuperContent.
	 * @param asSuperContent.
	 */
	public void setAsSuperContent(net.ihe.gazelle.medication.COCTMT230100UVSuperContent asSuperContent) {
	    this.asSuperContent = asSuperContent;
	}
	
	
	
	
	/**
	 * Return subContent.
	 * @return subContent
	 */
	public net.ihe.gazelle.medication.COCTMT230100UVSubContent getSubContent() {
	    return subContent;
	}
	
	/**
	 * Set a value to attribute subContent.
	 * @param subContent.
	 */
	public void setSubContent(net.ihe.gazelle.medication.COCTMT230100UVSubContent subContent) {
	    this.subContent = subContent;
	}
	
	
	
	
	/**
	 * Return classCode.
	 * @return classCode
	 */
	public net.ihe.gazelle.medication.EntityClassContainer getClassCode() {
	    return classCode;
	}
	
	/**
	 * Set a value to attribute classCode.
	 * @param classCode.
	 */
	public void setClassCode(net.ihe.gazelle.medication.EntityClassContainer classCode) {
	    this.classCode = classCode;
	}
	
	
	
	
	/**
	 * Return determinerCode.
	 * @return determinerCode
	 */
	public net.ihe.gazelle.medication.EntityDeterminer getDeterminerCode() {
	    return determinerCode;
	}
	
	/**
	 * Set a value to attribute determinerCode.
	 * @param determinerCode.
	 */
	public void setDeterminerCode(net.ihe.gazelle.medication.EntityDeterminer determinerCode) {
	    this.determinerCode = determinerCode;
	}
	
	
	
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.medication.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.medication.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "COCT_MT230100UV.PackagedMedicine").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(COCTMT230100UVPackagedMedicine cOCTMT230100UVPackagedMedicine, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (cOCTMT230100UVPackagedMedicine != null){
   			cvm.validate(cOCTMT230100UVPackagedMedicine, location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: cOCTMT230100UVPackagedMedicine.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.infr.AllInfrastructureRootTypeId.validateByModule(cOCTMT230100UVPackagedMedicine.getTypeId(), location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.infr.AllInfrastructureRootTemplateId templateId: cOCTMT230100UVPackagedMedicine.getTemplateId()){
					net.ihe.gazelle.infr.AllInfrastructureRootTemplateId.validateByModule(templateId, location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.medication.II.validateByModule(cOCTMT230100UVPackagedMedicine.getId(), location + "/id", cvm, diagnostic);
			net.ihe.gazelle.medication.CE.validateByModule(cOCTMT230100UVPackagedMedicine.getCode(), location + "/code", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.medication.TN name: cOCTMT230100UVPackagedMedicine.getName()){
					net.ihe.gazelle.medication.TN.validateByModule(name, location + "/name[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.medication.CE.validateByModule(cOCTMT230100UVPackagedMedicine.getFormCode(), location + "/formCode", cvm, diagnostic);
			net.ihe.gazelle.medication.ST1.validateByModule(cOCTMT230100UVPackagedMedicine.getLotNumberText(), location + "/lotNumberText", cvm, diagnostic);
			net.ihe.gazelle.medication.PQ.validateByModule(cOCTMT230100UVPackagedMedicine.getCapacityQuantity(), location + "/capacityQuantity", cvm, diagnostic);
			net.ihe.gazelle.medication.CE.validateByModule(cOCTMT230100UVPackagedMedicine.getCapTypeCode(), location + "/capTypeCode", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.medication.COCTMT230100UVManufacturedProduct asManufacturedProduct: cOCTMT230100UVPackagedMedicine.getAsManufacturedProduct()){
					net.ihe.gazelle.medication.COCTMT230100UVManufacturedProduct.validateByModule(asManufacturedProduct, location + "/asManufacturedProduct[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.medication.COCTMT230100UVSuperContent.validateByModule(cOCTMT230100UVPackagedMedicine.getAsSuperContent(), location + "/asSuperContent", cvm, diagnostic);
			net.ihe.gazelle.medication.COCTMT230100UVSubContent.validateByModule(cOCTMT230100UVPackagedMedicine.getSubContent(), location + "/subContent", cvm, diagnostic);
    	}
    }

}